--- a/scribus/CMakeLists.txt	2019-10-02 00:25:01.194386515 +0200
+++ b/scribus/CMakeLists.txt	2019-10-02 00:26:23.584392213 +0200
@@ -1069,7 +1069,9 @@
 	${SCRIBUS_GMAGICK_SRC}
 )
 
-if(NOT HAVE_HYPHEN)
+if(HAVE_HYPHEN)
+	include_directories(${HYPHEN_INCLUDE_DIR})
+else()
 	include_directories(third_party/hyphen)
 	set(SCRIBUS_SOURCES
 	${SCRIBUS_SOURCES}
@@ -1180,13 +1182,6 @@
 
 endif()
 
-if(HAVE_HYPHEN)
-	target_link_libraries(${EXE_NAME}
-	${HYPHEN_LIBRARY}
-	)
-endif()
-
-
 if(GESTURE_FRAME_PREVIEW)
 	 message(STATUS "Enable gesture frame preview [experimental]")
 	 set(GESTURE_FRAME_PREVIEW_SOURCES	pageitempreview.cpp)
@@ -1234,6 +1229,12 @@
 	)
 endif ()
 
+if(HAVE_HYPHEN)
+	target_link_libraries(${EXE_NAME}
+	${HYPHEN_LIBRARY}
+	)
+endif()
+
 if(WIN32)
 	set_target_properties(${EXE_NAME}
 		PROPERTIES
--- a/scribus/hyphenator.h	2019-07-31 00:35:05.000000000 +0200
+++ b/scribus/hyphenator.h	2019-10-02 00:00:42.497285638 +0200
@@ -13,7 +13,7 @@
 #include <QSet>
 
 #include "scribusapi.h"
-#include "third_party/hyphen/hyphen.h"
+#include <hyphen.h>
 
 class ScribusDoc;
 class ScribusMainWindow;