--- a/CMakeLists_Dependencies.cmake
+++ b/CMakeLists_Dependencies.cmake
@@ -954,6 +954,16 @@
 endif()
 #>>HUNSPELL for Speelling support
 
+#<<HYPHEN for Hyphenation support
+find_package(HYPHEN)
+if(HYPHEN_FOUND)
+	message("System Hyphen Found OK")
+	set(HAVE_HYPHEN ON)
+else()
+	message("Hyphen or its developer libraries NOT found - using bundled Hyphen instead")
+endif()
+#>>HYPHEN for Hyphenation support
+
 #<<PoDoFo for AI PDF import
 option(WITH_PODOFO "Enable support for PDF embedded in AI" ON)
 if (WITH_PODOFO)