From 3116328e804c7366ec64c4224cbf20b0f14e52c8 Mon Sep 17 00:00:00 2001
From: Jean Ghali <jghali@libertysurf.fr>
Date: Sun, 31 Mar 2024 21:40:42 +0000
Subject: [PATCH] Fix C++20 related warning "template-id is not allowed for
 constructor in C++20"

git-svn-id: svn://scribus.net/trunk/Scribus@26079 11d20701-8431-0410-a711-e3c959e3b870
--- a/scribus/third_party/lib2geom/rect.h
+++ b/scribus/third_party/lib2geom/rect.h
@@ -56,14 +56,14 @@ class D2<Interval> {
   private:
     Interval f[2];
   public:
-    D2<Interval>() { f[X] = f[Y] = Interval(0, 0); }
+    D2() { f[X] = f[Y] = Interval(0, 0); }
     
-    D2<Interval>(Interval const &a, Interval const &b) {
+    D2(Interval const &a, Interval const &b) {
         f[X] = a;
         f[Y] = b;
     }
 
-    D2<Interval>(Point const & a, Point const & b) {
+    D2(Point const & a, Point const & b) {
         f[X] = Interval(a[X], b[X]);
         f[Y] = Interval(a[Y], b[Y]);
     }