From 985b7944e50b23f4558ba4ca539659f37b4b7ba4 Mon Sep 17 00:00:00 2001
From: Jean Ghali <jghali@libertysurf.fr>
Date: Thu, 2 May 2024 22:26:03 +0000
Subject: [PATCH] Enforce C++20 when building with poppler >= 24.05.0

git-svn-id: svn://scribus.net/trunk/Scribus@26125 11d20701-8431-0410-a711-e3c959e3b870
--- a/CMakeLists_Dependencies.cmake
+++ b/CMakeLists_Dependencies.cmake
@@ -28,7 +28,14 @@ if (poppler_FOUND)
 	message(STATUS "Found poppler")
 	message(STATUS "Found poppler libs: ${poppler_LIBRARY}")
 	message(STATUS "Found poppler includes: ${poppler_INCLUDE_DIR}")
-	if (poppler_VERSION VERSION_GREATER_EQUAL 22.01.0)
+	if (poppler_VERSION VERSION_GREATER_EQUAL 24.05.0)
+		message(STATUS "Poppler Version:" ${poppler_VERSION})
+		if (CMAKE_CXX_STANDARD LESS 20)
+			message(STATUS "C++20 is the minimum C++ standard since poppler 24.05.0")
+			message(STATUS "Enabling C++20 compiler features")
+			set(CMAKE_CXX_STANDARD 20)
+		endif()
+	elseif (poppler_VERSION VERSION_GREATER_EQUAL 22.01.0)
 		message(STATUS "Poppler Version:" ${poppler_VERSION})
 		if (CMAKE_CXX_STANDARD LESS 17)
 			message(STATUS "C++17 is the minimum C++ standard since poppler 22.01.0")