From 874e1c13995223b1433026bc26e13911a74f3880 Mon Sep 17 00:00:00 2001
From: Andreas Sturmlechner <asturm@gentoo.org>
Date: Wed, 13 Nov 2024 23:19:51 +0100
Subject: [PATCH] Drop unused headers to fix build w/ poppler-24.11

Fix still pending upstream:
https://bugs.scribus.net/view.php?id=17308

Signed-off-by: Andreas Sturmlechner <asturm@gentoo.org>
---
 scribus/plugins/import/pdf/pdftextrecognition.h | 1 -
 scribus/plugins/import/pdf/slaoutput.h          | 2 --
 2 files changed, 3 deletions(-)

diff --git a/scribus/plugins/import/pdf/pdftextrecognition.h b/scribus/plugins/import/pdf/pdftextrecognition.h
index a04b45358..6edac9906 100644
--- a/scribus/plugins/import/pdf/pdftextrecognition.h
+++ b/scribus/plugins/import/pdf/pdftextrecognition.h
@@ -16,7 +16,6 @@ for which a new license (GPL+exception) is in place.
 #include "slaoutput.h"
 
 #include <poppler/GfxState.h>
-#include <poppler/CharCodeToUnicode.h>
 
 /* PDF TextBox Framework */
 /*
diff --git a/scribus/plugins/import/pdf/slaoutput.h b/scribus/plugins/import/pdf/slaoutput.h
index 69bebbf5f..ae7630d29 100644
--- a/scribus/plugins/import/pdf/slaoutput.h
+++ b/scribus/plugins/import/pdf/slaoutput.h
@@ -45,8 +45,6 @@ for which a new license (GPL+exception) is in place.
 #include <poppler/Form.h>
 #include <poppler/Page.h>
 #include <poppler/Catalog.h>
-#include <poppler/CharCodeToUnicode.h>
-#include <poppler/FontEncodingTables.h>
 #include <poppler/splash/SplashFontFileID.h>
 #include <poppler/splash/SplashFontFile.h>
 #include <poppler/splash/SplashFontEngine.h>
-- 
2.47.0